Index: palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4495)
@@ -869,5 +1149,8 @@
 
 
-    CHARACTER(LEN=10) ::  binary_version_local   !<
+    CHARACTER(LEN=10) ::  binary_version_local  !<
+    CHARACTER(LEN=20) ::  tmp_name              !<  temporary variable
+
+    INTEGER ::  i                               !<  loop index
 
 !
@@ -875,107 +1158,153 @@
     binary_version_local = '4.7'
 
-    CALL wrd_write_string( 'binary_version_local' )
-    WRITE ( 14 )  binary_version_local
-
-    WRITE ( 14 )  numprocs, myid, nxl, nxr, nys, nyn, nzb, nzt
-
-!
-!-- Attention: After changes to the following output commands the version number of the variable
-!-- ---------- binary_version_local must be changed!
-!--            Also, the list of arrays to be read in rrd_local must be adjusted accordingly.
-    CALL wrd_write_string( 'e' )
-    WRITE ( 14 )  e
-
-    IF ( ALLOCATED( e_av ) )  THEN
-       CALL wrd_write_string( 'e_av' )
-       WRITE ( 14 )  e_av
-    ENDIF
-
-    CALL wrd_write_string( 'kh' )
-    WRITE ( 14 )  kh
-
-
-    IF ( ALLOCATED( kh_av ) )  THEN
-       CALL wrd_write_string( 'kh_av' )
-       WRITE ( 14 )  kh_av
-    ENDIF
-
-    CALL wrd_write_string( 'km' )
-    WRITE ( 14 )  km
-
-    IF ( ALLOCATED( km_av ) )  THEN
-       CALL wrd_write_string( 'km_av' )
-       WRITE ( 14 )  km_av
-    ENDIF
-
-    IF ( ALLOCATED( lpt_av ) )  THEN
-       CALL wrd_write_string( 'lpt_av' )
-       WRITE ( 14 )  lpt_av
-    ENDIF
-
-    IF ( ALLOCATED( lwp_av ) )  THEN
-       CALL wrd_write_string( 'lwp_av' )
-       WRITE ( 14 )  lwp_av
-    ENDIF
-
-    CALL wrd_write_string( 'p' )
-    WRITE ( 14 )  p
-
-    IF ( ALLOCATED( p_av ) )  THEN
-       CALL wrd_write_string( 'p_av' )
-       WRITE ( 14 )  p_av
-    ENDIF
-
-    IF ( ALLOCATED( pc_av ) )  THEN
-       CALL wrd_write_string( 'pc_av' )
-       WRITE ( 14 )  pc_av
-    ENDIF
-
-    IF ( ALLOCATED( pr_av ) )  THEN
-       CALL wrd_write_string( 'pr_av' )
-       WRITE ( 14 )  pr_av
-    ENDIF
-
-    CALL wrd_write_string( 'pt' )
-    WRITE ( 14 )  pt
-
-    IF ( ALLOCATED( pt_av ) )  THEN
-       CALL wrd_write_string( 'pt_av' )
-       WRITE ( 14 )  pt_av
-    ENDIF
-
-    IF ( humidity )  THEN
-
-       CALL wrd_write_string( 'q' )
-       WRITE ( 14 )  q
-
-       IF ( ALLOCATED( q_av ) )  THEN
-          CALL wrd_write_string( 'q_av' )
-          WRITE ( 14 )  q_av
-       ENDIF
-
-       IF ( cloud_droplets )  THEN
-
-          CALL wrd_write_string( 'ql' )
-          WRITE ( 14 )  ql
-
-          IF ( ALLOCATED( ql_av ) )  THEN
-             CALL wrd_write_string( 'ql_av' )
-             WRITE ( 14 )  ql_av
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+!
+!--    Output in Fortran binary format
+
+       CALL wrd_write_string( 'binary_version_local' )
+       WRITE ( 14 )  binary_version_local
+
+       WRITE ( 14 )  numprocs, myid, nxl, nxr, nys, nyn, nzb, nzt
+
+!
+!--    Attention: After changes to the following output commands the version number of the variable
+!--    ---------- binary_version_local must be changed!
+!--               Also, the list of arrays to be read in rrd_local must be adjusted accordingly.
+       CALL wrd_write_string( 'e' )
+       WRITE ( 14 )  e
+
+       IF ( ALLOCATED( e_av ) )  THEN
+          CALL wrd_write_string( 'e_av' )
+          WRITE ( 14 )  e_av
+       ENDIF
+
+       CALL wrd_write_string( 'kh' )
+       WRITE ( 14 )  kh
+
+
+       IF ( ALLOCATED( kh_av ) )  THEN
+          CALL wrd_write_string( 'kh_av' )
+          WRITE ( 14 )  kh_av
+       ENDIF
+
+       CALL wrd_write_string( 'km' )
+       WRITE ( 14 )  km
+
+       IF ( ALLOCATED( km_av ) )  THEN
+          CALL wrd_write_string( 'km_av' )
+          WRITE ( 14 )  km_av
+       ENDIF
+
+       IF ( ALLOCATED( lpt_av ) )  THEN
+          CALL wrd_write_string( 'lpt_av' )
+          WRITE ( 14 )  lpt_av
+       ENDIF
+
+       IF ( ALLOCATED( lwp_av ) )  THEN
+          CALL wrd_write_string( 'lwp_av' )
+          WRITE ( 14 )  lwp_av
+       ENDIF
+
+       CALL wrd_write_string( 'p' )
+       WRITE ( 14 )  p
+
+       IF ( ALLOCATED( p_av ) )  THEN
+          CALL wrd_write_string( 'p_av' )
+          WRITE ( 14 )  p_av
+       ENDIF
+
+       IF ( ALLOCATED( pc_av ) )  THEN
+          CALL wrd_write_string( 'pc_av' )
+          WRITE ( 14 )  pc_av
+       ENDIF
+
+       IF ( ALLOCATED( pr_av ) )  THEN
+          CALL wrd_write_string( 'pr_av' )
+          WRITE ( 14 )  pr_av
+       ENDIF
+
+       CALL wrd_write_string( 'pt' )
+       WRITE ( 14 )  pt
+
+       IF ( ALLOCATED( pt_av ) )  THEN
+          CALL wrd_write_string( 'pt_av' )
+          WRITE ( 14 )  pt_av
+       ENDIF
+
+       IF ( humidity )  THEN
+
+          CALL wrd_write_string( 'q' )
+          WRITE ( 14 )  q
+
+          IF ( ALLOCATED( q_av ) )  THEN
+             CALL wrd_write_string( 'q_av' )
+             WRITE ( 14 )  q_av
           ENDIF
 
-       ENDIF
-
-       IF ( ALLOCATED( qsws_av ) )  THEN
-          CALL wrd_write_string( 'qsws_av' )
-          WRITE ( 14 )  qsws_av
-       ENDIF
-
-    ENDIF
-
-    IF ( passive_scalar )  THEN
-
-       CALL wrd_write_string( 's' )
-       WRITE ( 14 )  s
+          IF ( cloud_droplets )  THEN
+
+             CALL wrd_write_string( 'ql' )
+             WRITE ( 14 )  ql
+
+             IF ( ALLOCATED( ql_av ) )  THEN
+                CALL wrd_write_string( 'ql_av' )
+                WRITE ( 14 )  ql_av
+             ENDIF
+
+          ENDIF
+
+          IF ( ALLOCATED( qsws_av ) )  THEN
+             CALL wrd_write_string( 'qsws_av' )
+             WRITE ( 14 )  qsws_av
+          ENDIF
+
+       ENDIF
+
+       IF ( passive_scalar )  THEN
+
+          CALL wrd_write_string( 's' )
+          WRITE ( 14 )  s
+
+          IF ( ALLOCATED( s_av ) )  THEN
+             CALL wrd_write_string( 's_av' )
+             WRITE ( 14 )  s_av
+          ENDIF
+
+          IF ( ALLOCATED( ssws_av ) )  THEN
+             CALL wrd_write_string( 'ssws_av' )
+             WRITE ( 14 )  ssws_av
+          ENDIF
+
+       ENDIF
+
+       IF ( ALLOCATED( ql_c_av ) )  THEN
+          CALL wrd_write_string( 'ql_c_av' )
+          WRITE ( 14 )  ql_c_av
+       ENDIF
+
+       IF ( ALLOCATED( ql_v_av ) )  THEN
+          CALL wrd_write_string( 'ql_v_av' )
+          WRITE ( 14 )  ql_v_av
+       ENDIF
+
+       IF ( ALLOCATED( ql_vp_av ) )  THEN
+          CALL wrd_write_string( 'ql_vp_av' )
+          WRITE ( 14 )  ql_vp_av
+       ENDIF
+
+       IF ( ALLOCATED( qv_av ) )  THEN
+          CALL wrd_write_string( 'qv_av' )
+          WRITE ( 14 )  qv_av
+       ENDIF
+
+       CALL wrd_write_string( 'random_iv' )
+       WRITE ( 14 )  random_iv
+       WRITE ( 14 )  random_iy
+
+       IF ( ALLOCATED( seq_random_array ) )  THEN
+          CALL wrd_write_string( 'seq_random_array' )
+          WRITE ( 14 )  id_random_array
+          WRITE ( 14 )  seq_random_array
+       ENDIF
 
        IF ( ALLOCATED( s_av ) )  THEN
@@ -984,191 +1313,249 @@
        ENDIF
 
-       IF ( ALLOCATED( ssws_av ) )  THEN
-          CALL wrd_write_string( 'ssws_av' )
-          WRITE ( 14 )  ssws_av
-       ENDIF
+       IF ( ALLOCATED( shf_av ) )  THEN
+          CALL wrd_write_string( 'shf_av' )
+          WRITE ( 14 )  shf_av
+       ENDIF
+
+       IF ( ALLOCATED( ts_av ) )  THEN
+          CALL wrd_write_string( 'ts_av' )
+          WRITE ( 14 ) ts_av
+       ENDIF
+
+       CALL wrd_write_string( 'u' )
+       WRITE ( 14 )  u
+
+       IF ( ALLOCATED( u_av ) )  THEN
+          CALL wrd_write_string( 'u_av' )
+          WRITE ( 14 )  u_av
+       ENDIF
+
+       IF ( ALLOCATED( u_m_l ) )  THEN
+          CALL wrd_write_string( 'u_m_l' )
+          WRITE ( 14 )  u_m_l
+       ENDIF
+
+       IF ( ALLOCATED( u_m_n ) )  THEN
+          CALL wrd_write_string( 'u_m_n' )
+          WRITE ( 14 )  u_m_n
+       ENDIF
+
+       IF ( ALLOCATED( u_m_r ) )  THEN
+          CALL wrd_write_string( 'u_m_r' )
+          WRITE ( 14 )  u_m_r
+       ENDIF
+
+       IF ( ALLOCATED( u_m_s ) )  THEN
+          CALL wrd_write_string( 'u_m_s' )
+          WRITE ( 14 )  u_m_s
+       ENDIF
+
+       IF ( ALLOCATED( us_av ) )  THEN
+          CALL wrd_write_string( 'us_av' )
+          WRITE ( 14 )  us_av
+       ENDIF
+
+       CALL wrd_write_string( 'v' )
+       WRITE ( 14 )  v
+
+       IF ( ALLOCATED( v_av ) )  THEN
+          CALL wrd_write_string( 'v_av' )
+          WRITE ( 14 )  v_av
+       ENDIF
+
+       IF ( ALLOCATED( v_m_l  ) )  THEN
+          CALL wrd_write_string( 'v_m_l' )
+          WRITE ( 14 )  v_m_l
+       ENDIF
+
+       IF ( ALLOCATED( v_m_n ) )  THEN
+          CALL wrd_write_string( 'v_m_n' )
+         WRITE ( 14 )  v_m_n
+       ENDIF
+
+       IF ( ALLOCATED( v_m_r ) )  THEN
+          CALL wrd_write_string( 'v_m_r' )
+          WRITE ( 14 )  v_m_r
+       ENDIF
+
+       IF ( ALLOCATED( v_m_s ) )  THEN
+          CALL wrd_write_string( 'v_m_s' )
+          WRITE ( 14 )  v_m_s
+       ENDIF
+
+       IF ( humidity )  THEN
+
+          CALL wrd_write_string( 'vpt' )
+          WRITE ( 14 )  vpt
+
+          IF ( ALLOCATED( vpt_av ) )  THEN
+             CALL wrd_write_string( 'vpt_av' )
+             WRITE ( 14 ) vpt_av
+          ENDIF
+
+       ENDIF
+
+       CALL wrd_write_string( 'w' )
+       WRITE ( 14 )  w
+
+       IF ( ALLOCATED( w_av ) )  THEN
+          CALL wrd_write_string( 'w_av' )
+          WRITE ( 14 )  w_av
+       ENDIF
+
+       IF ( ALLOCATED( w_m_l ) )  THEN
+          CALL wrd_write_string( 'w_m_l' )
+          WRITE ( 14 )  w_m_l
+       ENDIF
+
+       IF ( ALLOCATED( w_m_n ) )  THEN
+          CALL wrd_write_string( 'w_m_n' )
+          WRITE ( 14 )  w_m_n
+       ENDIF
+
+       IF ( ALLOCATED( w_m_r ) )  THEN
+          CALL wrd_write_string( 'w_m_r' )
+          WRITE ( 14 )  w_m_r
+       ENDIF
+
+       IF ( ALLOCATED( w_m_s ) )  THEN
+          CALL wrd_write_string( 'w_m_s' )
+          WRITE ( 14 )  w_m_s
+       ENDIF
+
+       IF ( ALLOCATED( z0_av ) )  THEN
+          CALL wrd_write_string( 'z0_av' )
+          WRITE ( 14 )  z0_av
+       ENDIF
+
+      IF ( ALLOCATED( z0h_av ) )  THEN
+          CALL wrd_write_string( 'z0h_av' )
+          WRITE ( 14 )  z0h_av
+       ENDIF
+
+       IF ( ALLOCATED( z0q_av ) )  THEN
+          CALL wrd_write_string( 'z0q_av' )
+          WRITE ( 14 )  z0q_av
+       ENDIF
+
+       IF ( land_surface .OR. urban_surface )  THEN
+
+          IF ( ALLOCATED( ghf_av ) )  THEN
+             CALL wrd_write_string( 'ghf_av' )
+             WRITE ( 14 )  ghf_av
+          ENDIF
+
+          IF ( ALLOCATED( r_a_av ) )  THEN
+             CALL wrd_write_string( 'r_a_av' )
+             WRITE ( 14 )  r_a_av
+          ENDIF
+
+       ENDIF
+
+       IF ( ALLOCATED( tsurf_av ) )  THEN
+          CALL wrd_write_string( 'tsurf_av' )
+          WRITE ( 14 )  tsurf_av
+       ENDIF
+
+    ELSEIF ( restart_data_format_output == 'mpi' )  THEN
+!
+!--    Write local restart data using MPI-IO
+!--    Attention: After changes to the following output commands the version number
+!--    ---------  of the variable binary_version must be changed!
+!--               Also, the list of arrays to be read in rrd_local must be adjusted accordingly.
+       CALL wrd_mpi_io( 'e',  e)
+       IF ( ALLOCATED( e_av ) )  CALL wrd_mpi_io( 'e_av',  e_av)
+       CALL wrd_mpi_io( 'kh', kh )
+       IF ( ALLOCATED( kh_av ) )  CALL wrd_mpi_io( 'kh_av', kh_av )
+       CALL wrd_mpi_io( 'km' , km )
+       IF ( ALLOCATED( km_av ) )  CALL wrd_mpi_io( 'km_av', km_av )
+       IF ( ALLOCATED( lpt_av ) )  CALL wrd_mpi_io( 'lpt_av', lpt_av )
+       IF ( ALLOCATED( lwp_av ) )  CALL wrd_mpi_io( 'lwp_av', lwp_av )
+       CALL wrd_mpi_io( 'p', p )
+       IF ( ALLOCATED( p_av ) )  CALL wrd_mpi_io( 'p_av', p_av )
+       IF ( ALLOCATED( pc_av ) )  CALL wrd_mpi_io( 'pc_av', pc_av )
+       IF ( ALLOCATED( pr_av ) )  CALL wrd_mpi_io( 'pr_av', pr_av )
+       CALL wrd_mpi_io( 'pt', pt )
+       IF ( ALLOCATED( pt_av ) )  CALL wrd_mpi_io( 'pt_av', pt_av )
+
+       IF ( humidity )  THEN
+
+          CALL wrd_mpi_io( 'q', q )
+          IF ( ALLOCATED( q_av ) )  CALL wrd_mpi_io( 'q_av', q_av )
+
+          IF ( cloud_droplets )  THEN
+
+             CALL wrd_mpi_io( 'ql', ql )
+             IF ( ALLOCATED( ql_av ) )  CALL wrd_mpi_io( 'ql_av', ql_av )
+
+          ENDIF
+
+          IF ( ALLOCATED( qsws_av ) )  CALL wrd_mpi_io( 'qsws_av', qsws_av )
+
+       ENDIF
+
+       IF ( passive_scalar )  THEN
+
+          CALL wrd_mpi_io( 's', s )
+          IF ( ALLOCATED( s_av ) )  CALL wrd_mpi_io( 's_av',  s_av )
+          IF ( ALLOCATED( ssws_av ) )  CALL wrd_mpi_io( 'ssws_av', ssws_av )
+
+       ENDIF
+
+       IF ( ALLOCATED( ql_c_av ) )  CALL wrd_mpi_io( 'ql_c_av', ql_c_av )
+       IF ( ALLOCATED( ql_v_av ) )  CALL wrd_mpi_io( 'ql_v_av', ql_v_av )
+       IF ( ALLOCATED( ql_vp_av ) )  CALL wrd_mpi_io( 'ql_vp_av', ql_vp_av )
+       IF ( ALLOCATED( qv_av ) )  CALL wrd_mpi_io( 'qv_av', qv_av )
+!
+!--    Only PE0 writes random_iv and random_iy to restart file.
+!--    ATTENTION: If one value for every PE is required, the general approach of PE indendent
+!--    restart will be lost. That means that in general the parallel random number generator
+!--    in random_generatot_parallel_mod should be used!
+       CALL wrd_mpi_io_global_array( 'random_iv', random_iv )
+       CALL wrd_mpi_io( 'random_iy', random_iy )
+
+       IF ( ALLOCATED( seq_random_array ) )  THEN
+          CALL wrd_mpi_io( 'id_random_array', id_random_array )
+          DO  i = 1, SIZE( seq_random_array, 1 )
+             WRITE( tmp_name, '(A,I2.2)' )  'seq_random_array', i
+             CALL wrd_mpi_io( TRIM( tmp_name ), seq_random_array(i,:,:) )
+          ENDDO
+       ENDIF
+       IF ( ALLOCATED( s_av ) )  CALL wrd_mpi_io( 's_av', s_av )
+       IF ( ALLOCATED( shf_av ) )  CALL wrd_mpi_io( 'shf_av', shf_av )
+       IF ( ALLOCATED( ts_av ) )  CALL wrd_mpi_io( 'ts_av', ts_av )
+       CALL wrd_mpi_io( 'u', u)
+       IF ( ALLOCATED( u_av ) )  CALL wrd_mpi_io( 'u_av', u_av )
+       IF ( ALLOCATED( u_m_l ) )  CALL wrd_mpi_io( 'u_m_l', u_m_l )
+       IF ( ALLOCATED( u_m_n ) )  CALL wrd_mpi_io( 'u_m_n', u_m_n )
+       IF ( ALLOCATED( u_m_r ) )  CALL wrd_mpi_io( 'u_m_r', u_m_r )
+       IF ( ALLOCATED( u_m_s ) )  CALL wrd_mpi_io( 'u_m_s', u_m_s )
+       IF ( ALLOCATED( us_av ) )  CALL wrd_mpi_io( 'us_av', us_av )
+       CALL wrd_mpi_io( 'v', v )
+       IF ( ALLOCATED( v_av ) )  CALL wrd_mpi_io( 'v_av', v_av )
+       IF ( ALLOCATED( v_m_l ) )  CALL wrd_mpi_io( 'v_m_l', v_m_l )
+       IF ( ALLOCATED( v_m_n ) )  CALL wrd_mpi_io( 'v_m_n', v_m_n )
+       IF ( ALLOCATED( v_m_r ) )  CALL wrd_mpi_io( 'v_m_r', v_m_r )
+       IF ( ALLOCATED( v_m_s ) )  CALL wrd_mpi_io( 'v_m_s', v_m_s )
+       IF ( humidity )  THEN
+          CALL wrd_mpi_io( 'vpt',  vpt )
+          IF ( ALLOCATED( vpt_av ) )  CALL wrd_mpi_io( 'vpt_av', vpt_av )
+       ENDIF
+       CALL wrd_mpi_io( 'w', w)
+       IF ( ALLOCATED( w_av ) )  CALL wrd_mpi_io( 'w_av', w_av )
+       IF ( ALLOCATED( w_m_l ) )  CALL wrd_mpi_io( 'w_m_l', w_m_l )
+       IF ( ALLOCATED( w_m_n ) )  CALL wrd_mpi_io( 'w_m_n', w_m_n )
+       IF ( ALLOCATED( w_m_r ) )  CALL wrd_mpi_io( 'w_m_r', w_m_r )
+       IF ( ALLOCATED( w_m_s ) )  CALL wrd_mpi_io( 'w_m_s', w_m_s )
+       IF ( ALLOCATED( z0_av ) )  CALL wrd_mpi_io( 'z0_av', z0_av )
+       IF ( ALLOCATED( z0h_av ) )  CALL wrd_mpi_io( 'z0h_av', z0h_av )
+       IF ( ALLOCATED( z0q_av ) )  CALL wrd_mpi_io( 'z0q_av', z0q_av )
+       IF ( land_surface  .OR.  urban_surface )  THEN
+          IF ( ALLOCATED( ghf_av ) )  CALL wrd_mpi_io( 'ghf_av', ghf_av )
+          IF ( ALLOCATED( r_a_av ) )  CALL wrd_mpi_io( 'r_a_av', r_a_av )
+       ENDIF
+       IF ( ALLOCATED( tsurf_av ) )  CALL wrd_mpi_io( 'tsurf_av', tsurf_av )
 
     ENDIF
-
-    IF ( ALLOCATED( ql_c_av ) )  THEN
-       CALL wrd_write_string( 'ql_c_av' )
-       WRITE ( 14 )  ql_c_av
-    ENDIF
-
-    IF ( ALLOCATED( ql_v_av ) )  THEN
-       CALL wrd_write_string( 'ql_v_av' )
-       WRITE ( 14 )  ql_v_av
-    ENDIF
-
-    IF ( ALLOCATED( ql_vp_av ) )  THEN
-       CALL wrd_write_string( 'ql_vp_av' )
-       WRITE ( 14 )  ql_vp_av
-    ENDIF
-
-    IF ( ALLOCATED( qv_av ) )  THEN
-       CALL wrd_write_string( 'qv_av' )
-       WRITE ( 14 )  qv_av
-    ENDIF
-
-    CALL wrd_write_string( 'random_iv' )
-    WRITE ( 14 )  random_iv
-    WRITE ( 14 )  random_iy
-
-    IF ( ALLOCATED( seq_random_array ) )  THEN
-       CALL wrd_write_string( 'seq_random_array' )
-       WRITE ( 14 )  id_random_array
-       WRITE ( 14 )  seq_random_array
-    ENDIF
-
-    IF ( ALLOCATED( s_av ) )  THEN
-       CALL wrd_write_string( 's_av' )
-       WRITE ( 14 )  s_av
-    ENDIF
-
-    IF ( ALLOCATED( shf_av ) )  THEN
-       CALL wrd_write_string( 'shf_av' )
-       WRITE ( 14 )  shf_av
-    ENDIF
-
-    IF ( ALLOCATED( ts_av ) )  THEN
-       CALL wrd_write_string( 'ts_av' )
-       WRITE ( 14 ) ts_av
-    ENDIF
-
-    CALL wrd_write_string( 'u' )
-    WRITE ( 14 )  u
-
-    IF ( ALLOCATED( u_av ) )  THEN
-       CALL wrd_write_string( 'u_av' )
-       WRITE ( 14 )  u_av
-    ENDIF
-
-    IF ( ALLOCATED( u_m_l ) )  THEN
-       CALL wrd_write_string( 'u_m_l' )
-       WRITE ( 14 )  u_m_l
-    ENDIF
-
-    IF ( ALLOCATED( u_m_n ) )  THEN
-       CALL wrd_write_string( 'u_m_n' )
-       WRITE ( 14 )  u_m_n
-    ENDIF
-
-    IF ( ALLOCATED( u_m_r ) )  THEN
-       CALL wrd_write_string( 'u_m_r' )
-       WRITE ( 14 )  u_m_r
-    ENDIF
-
-    IF ( ALLOCATED( u_m_s ) )  THEN
-       CALL wrd_write_string( 'u_m_s' )
-       WRITE ( 14 )  u_m_s
-    ENDIF
-
-    IF ( ALLOCATED( us_av ) )  THEN
-       CALL wrd_write_string( 'us_av' )
-       WRITE ( 14 )  us_av
-    ENDIF
-
-    CALL wrd_write_string( 'v' )
-    WRITE ( 14 )  v
-
-    IF ( ALLOCATED( v_av ) )  THEN
-       CALL wrd_write_string( 'v_av' )
-       WRITE ( 14 )  v_av
-    ENDIF
-
-    IF ( ALLOCATED( v_m_l  ) )  THEN
-       CALL wrd_write_string( 'v_m_l' )
-       WRITE ( 14 )  v_m_l
-    ENDIF
-
-    IF ( ALLOCATED( v_m_n ) )  THEN
-       CALL wrd_write_string( 'v_m_n' )
-       WRITE ( 14 )  v_m_n
-    ENDIF
-
-    IF ( ALLOCATED( v_m_r ) )  THEN
-       CALL wrd_write_string( 'v_m_r' )
-       WRITE ( 14 )  v_m_r
-    ENDIF
-
-    IF ( ALLOCATED( v_m_s ) )  THEN
-       CALL wrd_write_string( 'v_m_s' )
-       WRITE ( 14 )  v_m_s
-    ENDIF
-
-    IF ( humidity )  THEN
-
-       CALL wrd_write_string( 'vpt' )
-       WRITE ( 14 )  vpt
-
-       IF ( ALLOCATED( vpt_av ) )  THEN
-          CALL wrd_write_string( 'vpt_av' )
-          WRITE ( 14 ) vpt_av
-       ENDIF
-
-    ENDIF
-
-    CALL wrd_write_string( 'w' )
-    WRITE ( 14 )  w
-
-    IF ( ALLOCATED( w_av ) )  THEN
-       CALL wrd_write_string( 'w_av' )
-       WRITE ( 14 )  w_av
-    ENDIF
-
-    IF ( ALLOCATED( w_m_l ) )  THEN
-       CALL wrd_write_string( 'w_m_l' )
-       WRITE ( 14 )  w_m_l
-    ENDIF
-
-    IF ( ALLOCATED( w_m_n ) )  THEN
-       CALL wrd_write_string( 'w_m_n' )
-       WRITE ( 14 )  w_m_n
-    ENDIF
-
-    IF ( ALLOCATED( w_m_r ) )  THEN
-       CALL wrd_write_string( 'w_m_r' )
-       WRITE ( 14 )  w_m_r
-    ENDIF
-
-    IF ( ALLOCATED( w_m_s ) )  THEN
-       CALL wrd_write_string( 'w_m_s' )
-       WRITE ( 14 )  w_m_s
-    ENDIF
-
-    IF ( ALLOCATED( z0_av ) )  THEN
-       CALL wrd_write_string( 'z0_av' )
-       WRITE ( 14 )  z0_av
-    ENDIF
-
-    IF ( ALLOCATED( z0h_av ) )  THEN
-       CALL wrd_write_string( 'z0h_av' )
-       WRITE ( 14 )  z0h_av
-    ENDIF
-
-    IF ( ALLOCATED( z0q_av ) )  THEN
-       CALL wrd_write_string( 'z0q_av' )
-       WRITE ( 14 )  z0q_av
-    ENDIF
-
-    IF ( land_surface .OR. urban_surface )  THEN
-
-       IF ( ALLOCATED( ghf_av ) )  THEN
-          CALL wrd_write_string( 'ghf_av' )
-          WRITE ( 14 )  ghf_av
-       ENDIF
-
-       IF ( ALLOCATED( r_a_av ) )  THEN
-          CALL wrd_write_string( 'r_a_av' )
-          WRITE ( 14 )  r_a_av
-       ENDIF
-
-    ENDIF
-
-    IF ( ALLOCATED( tsurf_av ) )  THEN
-       CALL wrd_write_string( 'tsurf_av' )
-       WRITE ( 14 )  tsurf_av
-    ENDIF
-
 
     CALL surface_wrd_local
@@ -1180,5 +1567,7 @@
 !
 !-- Write end label
-    CALL wrd_write_string( '*** end ***' )
+    IF (  restart_data_format_output == 'fortran_binary' )  THEN
+       CALL wrd_write_string( '*** end ***' )
+    ENDIF
 
  END SUBROUTINE wrd_local
